/*
  Free Download Manager Copyright (c) 2003-2011 FreeDownloadManager.ORG
*/

#include "stdafx.h"
#include "vmsCharsets.h"

static struct _charsetInfo
{
    UINT id;
    LPCSTR charset;
    UINT codepage;
    UINT stateful;
} const charsetInfo[] =
{
  {   1, "adobe-standard-encoding",                           0,  0 }, 
  {   1, "csadobestandardencoding",                           0,  0 }, 
  {   2, "adobe-symbol-encoding",                             0,  0 }, 
  {   2, "cshppsmath",                                        0,  0 }, 
  {   3, "iso-ir-99",                                         0,  0 }, 
  {   3, "ansi_x3.110-1983",                                  0,  0 }, 
  {   3, "csa_t500-1983",                                     0,  0 }, 
  {   3, "naplps",                                            0,  0 }, 
  {   3, "csiso99naplps",                                     0,  0 }, 
  {   4, "us-ascii",                                      20127,  0 }, 
  {   4, "iso-ir-6",                                      20127,  0 }, 
  {   4, "ansi_x3.4-1968",                                20127,  0 }, 
  {   4, "ansi_x3.4-1986",                                20127,  0 }, 
  {   4, "iso_646.irv:1991",                              20127,  0 }, 
  {   4, "ascii",                                         20127,  0 }, 
  {   4, "iso646-us",                                     20127,  0 }, 
  {   4, "us",                                            20127,  0 }, 
  {   4, "ibm367",                                        20127,  0 }, 
  {   4, "cp367",                                         20127,  0 }, 
  {   4, "csascii",                                       20127,  0 }, 
  {   4, "iso-ir-6us",                                    20127,  0 }, 
  {   5, "iso-ir-89",                                         0,  0 }, 
  {   5, "asmo_449",                                          0,  0 }, 
  {   5, "iso_9036",                                          0,  0 }, 
  {   5, "arabic7",                                           0,  0 }, 
  {   5, "csiso89asmo449",                                    0,  0 }, 
  {   6, "big5",                                            950,  0 }, 
  {   6, "csbig5",                                          950,  0 }, 
  {   6, "cn-big5",                                         950,  0 }, 
  {   6, "x-x-big5",                                        950,  0 }, 
  {   7, "big5-hkscs",                                      950,  0 }, 
  {   7, "cn-big5",                                         950,  0 }, 
  {   7, "x-x-big5",                                        950,  0 }, 
  {   8, "bocu-1",                                            0,  0 }, 
  {   8, "csbocu-1",                                          0,  0 }, 
  {   9, "iso-ir-4",                                          0,  0 }, 
  {   9, "bs_4730",                                           0,  0 }, 
  {   9, "iso646-gb",                                         0,  0 }, 
  {   9, "gb",                                                0,  0 }, 
  {   9, "uk",                                                0,  0 }, 
  {   9, "csiso4unitedkingdom",                               0,  0 }, 
  {  10, "iso-ir-47",                                         0,  0 }, 
  {  10, "bs_viewdata",                                       0,  0 }, 
  {  10, "csiso47bsviewdata",                                 0,  0 }, 
  {  11, "cesu-8",                                            0,  0 }, 
  {  11, "cscesu-8",                                          0,  0 }, 
  {  12, "iso-ir-121",                                        0,  0 }, 
  {  12, "csa_z243.4-1985-1",                                 0,  0 }, 
  {  12, "iso646-ca",                                         0,  0 }, 
  {  12, "csa7-1",                                            0,  0 }, 
  {  12, "ca",                                                0,  0 }, 
  {  12, "csiso121canadian1",                                 0,  0 }, 
  {  13, "iso-ir-122",                                        0,  0 }, 
  {  13, "csa_z243.4-1985-2",                                 0,  0 }, 
  {  13, "iso646-ca2",                                        0,  0 }, 
  {  13, "csa7-2",                                            0,  0 }, 
  {  13, "csiso122canadian2",                                 0,  0 }, 
  {  14, "iso-ir-123",                                        0,  0 }, 
  {  14, "csa_z243.4-1985-gr",                                0,  0 }, 
  {  14, "csiso123csaz24341985gr",                            0,  0 }, 
  {  15, "iso-ir-139",                                        0,  0 }, 
  {  15, "csn_369103",                                        0,  0 }, 
  {  15, "csiso139csn369103",                                 0,  0 }, 
  {  16, "dec-mcs",                                           0,  0 }, 
  {  16, "dec",                                               0,  0 }, 
  {  16, "csdecmcs",                                          0,  0 }, 
  {  17, "iso-ir-21",                                     20106,  0 }, 
  {  17, "din_66003",                                     20106,  0 }, 
  {  17, "de",                                            20106,  0 }, 
  {  17, "iso646-de",                                     20106,  0 }, 
  {  17, "csiso21german",                                 20106,  0 }, 
  {  17, "x-ia5-german",                                  20106,  0 }, 
  {  18, "dk-us",                                             0,  0 }, 
  {  18, "csdkus",                                            0,  0 }, 
  {  19, "ds_2089",                                           0,  0 }, 
  {  19, "ds2089",                                            0,  0 }, 
  {  19, "iso646-dk",                                         0,  0 }, 
  {  19, "dk",                                                0,  0 }, 
  {  19, "csiso646danish",                                    0,  0 }, 
  {  20, "ebcdic-at-de",                                      0,  0 }, 
  {  20, "csibmebcdicatde",                                   0,  0 }, 
  {  21, "ebcdic-at-de-a",                                    0,  0 }, 
  {  21, "csebcdicatdea",                                     0,  0 }, 
  {  22, "ebcdic-ca-fr",                                      0,  0 }, 
  {  22, "csebcdiccafr",                                      0,  0 }, 
  {  23, "ebcdic-dk-0",                                      0,  0 }, 
  {  23, "csebcdicdkno",                                      0,  0 }, 
  {  24, "ebcdic-dk-0-a",                                    0,  0 }, 
  {  24, "csebcdicdknoa",                                     0,  0 }, 
  {  25, "ebcdic-es",                                         0,  0 }, 
  {  25, "csebcdices",                                        0,  0 }, 
  {  26, "ebcdic-es-a",                                       0,  0 }, 
  {  26, "csebcdicesa",                                       0,  0 }, 
  {  27, "ebcdic-es-s",                                       0,  0 }, 
  {  27, "csebcdicess",                                       0,  0 }, 
  {  28, "ebcdic-fi-se",                                      0,  0 }, 
  {  28, "csebcdicfise",                                      0,  0 }, 
  {  29, "ebcdic-fi-se-a",                                    0,  0 }, 
  {  29, "csebcdicfisea",                                     0,  0 }, 
  {  30, "ebcdic-fr",                                         0,  0 }, 
  {  30, "csebcdicfr",                                        0,  0 }, 
  {  31, "ebcdic-it",                                         0,  0 }, 
  {  31, "csebcdicit",                                        0,  0 }, 
  {  32, "ebcdic-pt",                                         0,  0 }, 
  {  32, "csebcdicpt",                                        0,  0 }, 
  {  33, "ebcdic-uk",                                         0,  0 }, 
  {  33, "csebcdicuk",                                        0,  0 }, 
  {  34, "ebcdic-us",                                         0,  0 }, 
  {  34, "csebcdicus",                                        0,  0 }, 
  {  35, "iso-ir-111",                                        0,  0 }, 
  {  35, "ecma-cyrillic",                                     0,  0 }, 
  {  35, "csiso111ecmacyrillic",                              0,  0 }, 
  {  36, "iso-ir-17",                                         0,  0 }, 
  {  36, "es",                                                0,  0 }, 
  {  36, "iso646-es",                                         0,  0 }, 
  {  36, "csiso17spanish",                                    0,  0 }, 
  {  37, "iso-ir-85",                                         0,  0 }, 
  {  37, "es2",                                               0,  0 }, 
  {  37, "iso646-es2",                                        0,  0 }, 
  {  37, "csiso85spanish2",                                   0,  0 }, 
  {  38, "euc-kr",                                        51949,  0 }, 
  {  38, "cseuckr",                                       51949,  0 }, 
  {  39, "extended_unix_code_fixed_width_for_japanese",       0,  0 }, 
  {  39, "cseucfixwidjapanese",                               0,  0 }, 
  {  40, "euc-jp",                                        51932,  0 }, 
  {  40, "extended_unix_code_packed_format_for_japanese", 51932,  0 }, 
  {  40, "cseucpkdfmtjapanese",                           51932,  0 }, 
  {  40, "x-euc-jp",                                      51932,  0 }, 
  {  40, "x-euc",                                         51932,  0 }, 
  {  41, "gb18030",                                       54936,  0 }, 
  {  42, "gb2312",                                          936,  0 }, 
  {  42, "csgb2312",                                        936,  0 }, 
  {  42, "csgb231280",                                      936,  0 }, 
  {  42, "gb2312-80",                                       936,  0 }, 
  {  42, "gb231280",                                        936,  0 }, 
  {  42, "cn-gb",                                           936,  0 }, 
  {  43, "iso-ir-57",                                         0,  0 }, 
  {  43, "gb_1988-80",                                        0,  0 }, 
  {  43, "cn",                                                0,  0 }, 
  {  43, "iso646-cn",                                         0,  0 }, 
  {  43, "csiso57gb1988",                                     0,  0 }, 
  {  44, "iso-ir-58",                                       936,  0 }, 
  {  44, "gb_2312-80",                                      936,  0 }, 
  {  44, "chinese",                                         936,  0 }, 
  {  44, "csiso58gb231280",                                 936,  0 }, 
  {  44, "csgb231280",                                      936,  0 }, 
  {  44, "gb2312-80",                                       936,  0 }, 
  {  44, "gb231280",                                        936,  0 }, 
  {  44, "cn-gb",                                           936,  0 }, 
  {  45, "gbk",                                             936,  0 }, 
  {  45, "cp936",                                           936,  0 }, 
  {  45, "ms936",                                           936,  0 }, 
  {  45, "windows-936",                                     936,  0 }, 
  {  45, "csgb231280",                                      936,  0 }, 
  {  45, "gb2312-80",                                       936,  0 }, 
  {  45, "gb231280",                                        936,  0 }, 
  {  45, "cn-gb",                                           936,  0 }, 
  {  46, "iso-ir-153",                                        0,  0 }, 
  {  46, "gost_19768-74",                                     0,  0 }, 
  {  46, "st_sev_358-88",                                     0,  0 }, 
  {  46, "csiso153gost1976874",                               0,  0 }, 
  {  47, "iso-ir-150",                                        0,  0 }, 
  {  47, "greek-ccitt",                                       0,  0 }, 
  {  47, "csiso150",                                          0,  0 }, 
  {  47, "csiso150greekccitt",                                0,  0 }, 
  {  48, "iso-ir-88",                                         0,  0 }, 
  {  48, "greek7",                                            0,  0 }, 
  {  48, "csiso88greek7",                                     0,  0 }, 
  {  49, "iso-ir-18",                                         0,  0 }, 
  {  49, "greek7-old",                                        0,  0 }, 
  {  49, "csiso18greek7old",                                  0,  0 }, 
  {  50, "hp-desktop",                                        0,  0 }, 
  {  50, "cshpdesktop",                                       0,  0 }, 
  {  51, "hp-legal",                                          0,  0 }, 
  {  51, "cshplegal",                                         0,  0 }, 
  {  52, "hp-math8",                                          0,  0 }, 
  {  52, "cshpmath8",                                         0,  0 }, 
  {  53, "hp-pi-font",                                        0,  0 }, 
  {  53, "cshppifont",                                        0,  0 }, 
  {  54, "hp-roman8",                                         0,  0 }, 
  {  54, "roman8",                                            0,  0 }, 
  {  54, "r8",                                                0,  0 }, 
  {  54, "cshproman8",                                        0,  0 }, 
  {  55, "hz-gb-2312",                                    52936, 1 }, 
  {  56, "ibm-symbols",                                       0,  0 }, 
  {  56, "csibmsymbols",                                      0,  0 }, 
  {  57, "ibm-thai",                                      20838,  0 }, 
  {  57, "csibmthai",                                     20838,  0 }, 
  {  57, "x-ebcdic-thai",                                 20838,  0 }, 
  {  58, "ibm00858",                                        858,  0 }, 
  {  58, "ccsid00858",                                      858,  0 }, 
  {  58, "cp00858",                                         858,  0 }, 
  {  58, "pc-multilingual-850+euro",                        858,  0 }, 
  {  59, "ibm00924",                                      20924,  0 }, 
  {  59, "ccsid00924",                                    20924,  0 }, 
  {  59, "cp00924",                                       20924,  0 }, 
  {  59, "ebcdic-latin9--euro",                           20924,  0 }, 
  {  60, "ibm01140",                                       1140,  0 }, 
  {  60, "ccsid01140",                                     1140,  0 }, 
  {  60, "cp01140",                                        1140,  0 }, 
  {  60, "ebcdic-us-37+euro",                              1140,  0 }, 
  {  60, "x-ebcdic-cp-us-euro",                            1140,  0 }, 
  {  61, "ibm01141",                                       1141,  0 }, 
  {  61, "ccsid01141",                                     1141,  0 }, 
  {  61, "cp01141",                                        1141,  0 }, 
  {  61, "ebcdic-de-273+euro",                             1141,  0 }, 
  {  61, "x-ebcdic-germany-euro",                          1141,  0 }, 
  {  62, "ibm01142",                                       1142,  0 }, 
  {  62, "ccsid01142",                                     1142,  0 }, 
  {  62, "cp01142",                                        1142,  0 }, 
  {  62, "ebcdic-dk-277+euro",                             1142,  0 }, 
  {  62, "ebcdic-0-277+euro",                             1142,  0 }, 
  {  62, "x-ebcdic-denmarknorway-euro",                    1142,  0 }, 
  {  63, "ibm01143",                                       1143,  0 }, 
  {  63, "ccsid01143",                                     1143,  0 }, 
  {  63, "cp01143",                                        1143,  0 }, 
  {  63, "ebcdic-fi-278+euro",                             1143,  0 }, 
  {  63, "ebcdic-se-278+euro",                             1143,  0 }, 
  {  63, "x-ebcdic-france",                                1143,  0 }, 
  {  63, "x-ebcdic-finlandsweden-euro",                    1143,  0 }, 
  {  64, "ibm01144",                                       1144,  0 }, 
  {  64, "ccsid01144",                                     1144,  0 }, 
  {  64, "cp01144",                                        1144,  0 }, 
  {  64, "ebcdic-it-280+euro",                             1144,  0 }, 
  {  64, "x-ebcdic-italy-euro",                            1144,  0 }, 
  {  65, "ibm01145",                                       1145,  0 }, 
  {  65, "ccsid01145",                                     1145,  0 }, 
  {  65, "cp01145",                                        1145,  0 }, 
  {  65, "ebcdic-es-284+euro",                             1145,  0 }, 
  {  65, "x-ebcdic-spain-euro",                            1145,  0 }, 
  {  66, "ibm01146",                                       1146,  0 }, 
  {  66, "ccsid01146",                                     1146,  0 }, 
  {  66, "cp01146",                                        1146,  0 }, 
  {  66, "ebcdic-gb-285+euro",                             1146,  0 }, 
  {  66, "x-ebcdic-uk-euro",                               1146,  0 }, 
  {  67, "ibm01147",                                       1147,  0 }, 
  {  67, "ccsid01147",                                     1147,  0 }, 
  {  67, "cp01147",                                        1147,  0 }, 
  {  67, "ebcdic-fr-297+euro",                             1147,  0 }, 
  {  67, "x-ebcdic-france-euro",                           1147,  0 }, 
  {  68, "ibm01148",                                       1148,  0 }, 
  {  68, "ccsid01148",                                     1148,  0 }, 
  {  68, "cp01148",                                        1148,  0 }, 
  {  68, "ebcdic-international-500+euro",                  1148,  0 }, 
  {  68, "x-ebcdic-international-euro",                    1148,  0 }, 
  {  69, "ibm01149",                                       1149,  0 }, 
  {  69, "ccsid01149",                                     1149,  0 }, 
  {  69, "cp01149",                                        1149,  0 }, 
  {  69, "ebcdic-is-871+euro",                             1149,  0 }, 
  {  69, "x-ebcdic-icelandic-euro",                        1149,  0 }, 
  {  70, "ibm037",                                           37,  0 }, 
  {  70, "cp037",                                            37,  0 }, 
  {  70, "ebcdic-cp-us",                                     37,  0 }, 
  {  70, "ebcdic-cp-ca",                                     37,  0 }, 
  {  70, "ebcdic-cp-wt",                                     37,  0 }, 
  {  70, "ebcdic-cp-nl",                                     37,  0 }, 
  {  70, "csibm037",                                         37,  0 }, 
  {  71, "ibm038",                                            0,  0 }, 
  {  71, "ebcdic-int",                                        0,  0 }, 
  {  71, "cp038",                                             0,  0 }, 
  {  71, "csibm038",                                          0,  0 }, 
  {  72, "ibm1026",                                        1026,  0 }, 
  {  72, "cp1026",                                         1026,  0 }, 
  {  72, "csibm1026",                                      1026,  0 }, 
  {  73, "ibm1047",                                           0,  0 }, 
  {  73, "ibm-1047",                                          0,  0 }, 
  {  74, "ibm273",                                        20273,  0 }, 
  {  74, "cp273",                                         20273,  0 }, 
  {  74, "csibm273",                                      20273,  0 }, 
  {  74, "x-ebcdic-germany",                              20273,  0 }, 
  {  75, "ibm274",                                            0,  0 }, 
  {  75, "ebcdic-be",                                         0,  0 }, 
  {  75, "cp274",                                             0,  0 }, 
  {  75, "csibm274",                                          0,  0 }, 
  {  76, "ibm275",                                            0,  0 }, 
  {  76, "ebcdic-br",                                         0,  0 }, 
  {  76, "cp275",                                             0,  0 }, 
  {  76, "csibm275",                                          0,  0 }, 
  {  77, "ibm277",                                        20277,  0 }, 
  {  77, "ebcdic-cp-dk",                                  20277,  0 }, 
  {  77, "ebcdic-cp-0",                                  20277,  0 }, 
  {  77, "csibm277",                                      20277,  0 }, 
  {  77, "x-ebcdic-denmarknorway",                        20277,  0 }, 
  {  78, "ibm278",                                        20278,  0 }, 
  {  78, "cp278",                                         20278,  0 }, 
  {  78, "ebcdic-cp-fi",                                  20278,  0 }, 
  {  78, "ebcdic-cp-se",                                  20278,  0 }, 
  {  78, "csibm278",                                      20278,  0 }, 
  {  78, "x-ebcdic-finlandsweden",                        20278,  0 }, 
  {  79, "ibm280",                                        20280,  0 }, 
  {  79, "cp280",                                         20280,  0 }, 
  {  79, "ebcdic-cp-it",                                  20280,  0 }, 
  {  79, "csibm280",                                      20280,  0 }, 
  {  79, "x-ebcdic-italy",                                20280,  0 }, 
  {  80, "ibm281",                                            0,  0 }, 
  {  80, "ebcdic-jp-e",                                       0,  0 }, 
  {  80, "cp281",                                             0,  0 }, 
  {  80, "csibm281",                                          0,  0 }, 
  {  81, "ibm284",                                        20284,  0 }, 
  {  81, "cp284",                                         20284,  0 }, 
  {  81, "ebcdic-cp-es",                                  20284,  0 }, 
  {  81, "csibm284",                                      20284,  0 }, 
  {  81, "x-ebcdic-spain",                                20284,  0 }, 
  {  82, "ibm285",                                        20285,  0 }, 
  {  82, "cp285",                                         20285,  0 }, 
  {  82, "ebcdic-cp-gb",                                  20285,  0 }, 
  {  82, "csibm285",                                      20285,  0 }, 
  {  82, "x-ebcdic-uk",                                   20285,  0 }, 
  {  83, "ibm290",                                        20290,  0 }, 
  {  83, "cp290",                                         20290,  0 }, 
  {  83, "ebcdic-jp-kana",                                20290,  0 }, 
  {  83, "csibm290",                                      20290,  0 }, 
  {  83, "x-ebcdic-japanesekatakana",                     20290,  0 }, 
  {  84, "ibm297",                                        20297,  0 }, 
  {  84, "cp297",                                         20297,  0 }, 
  {  84, "ebcdic-cp-fr",                                  20297,  0 }, 
  {  84, "csibm297",                                      20297,  0 }, 
  {  85, "ibm420",                                        20420,  0 }, 
  {  85, "cp420",                                         20420,  0 }, 
  {  85, "ebcdic-cp-ar1",                                 20420,  0 }, 
  {  85, "csibm420",                                      20420,  0 }, 
  {  85, "x-ebcdic-arabic",                               20420,  0 }, 
  {  86, "ibm423",                                        20423,  0 }, 
  {  86, "cp423",                                         20423,  0 }, 
  {  86, "ebcdic-cp-gr",                                  20423,  0 }, 
  {  86, "csibm423",                                      20423,  0 }, 
  {  86, "x-ebcdic-greek",                                20423,  0 }, 
  {  87, "ibm424",                                        20424,  0 }, 
  {  87, "cp424",                                         20424,  0 }, 
  {  87, "ebcdic-cp-he",                                  20424,  0 }, 
  {  87, "csibm424",                                      20424,  0 }, 
  {  87, "x-ebcdic-hebrew",                               20424,  0 }, 
  {  88, "ibm437",                                          437,  0 }, 
  {  88, "cp437",                                           437,  0 }, 
  {  88, "437",                                             437,  0 }, 
  {  88, "cspc8codepage437",                                437,  0 }, 
  {  88, "codepage437",                                     437,  0 }, 
  {  88, "cspc8",                                           437,  0 }, 
  {  89, "ibm500",                                          500,  0 }, 
  {  89, "cp500",                                           500,  0 }, 
  {  89, "ebcdic-cp-be",                                    500,  0 }, 
  {  89, "ebcdic-cp-ch",                                    500,  0 }, 
  {  89, "csibm500",                                        500,  0 }, 
  {  90, "ibm775",                                          775,  0 }, 
  {  90, "cp775",                                           775,  0 }, 
  {  90, "cspc775baltic",                                   775,  0 }, 
  {  91, "ibm850",                                          850,  0 }, 
  {  91, "cp850",                                           850,  0 }, 
  {  91, "850",                                             850,  0 }, 
  {  91, "cspc850multilingual",                             850,  0 }, 
  {  92, "ibm851",                                            0,  0 }, 
  {  92, "cp851",                                             0,  0 }, 
  {  92, "851",                                               0,  0 }, 
  {  92, "csibm851",                                          0,  0 }, 
  {  93, "ibm852",                                          852,  0 }, 
  {  93, "cp852",                                           852,  0 }, 
  {  93, "852",                                             852,  0 }, 
  {  93, "cspcp852",                                        852,  0 }, 
  {  94, "ibm855",                                          855,  0 }, 
  {  94, "cp855",                                           855,  0 }, 
  {  94, "855",                                             855,  0 }, 
  {  94, "csibm855",                                        855,  0 }, 
  {  95, "ibm857",                                          857,  0 }, 
  {  95, "cp857",                                           857,  0 }, 
  {  95, "857",                                             857,  0 }, 
  {  95, "csibm857",                                        857,  0 }, 
  {  96, "ibm860",                                          860,  0 }, 
  {  96, "cp860",                                           860,  0 }, 
  {  96, "860",                                             860,  0 }, 
  {  96, "csibm860",                                        860,  0 }, 
  {  97, "ibm861",                                          861,  0 }, 
  {  97, "cp861",                                           861,  0 }, 
  {  97, "861",                                             861,  0 }, 
  {  97, "cp-is",                                           861,  0 }, 
  {  97, "csibm861",                                        861,  0 }, 
  {  98, "ibm862",                                          862,  0 }, 
  {  98, "cp862",                                           862,  0 }, 
  {  98, "862",                                             862,  0 }, 
  {  98, "cspc862latinhebrew",                              862,  0 }, 
  {  98, "dos-862",                                         862,  0 }, 
  {  99, "ibm863",                                          863,  0 }, 
  {  99, "cp863",                                           863,  0 }, 
  {  99, "863",                                             863,  0 }, 
  {  99, "csibm863",                                        863,  0 }, 
  { 100, "ibm864",                                          864,  0 }, 
  { 100, "cp864",                                           864,  0 }, 
  { 100, "csibm864",                                        864,  0 }, 
  { 101, "ibm865",                                          865,  0 }, 
  { 101, "cp865",                                           865,  0 }, 
  { 101, "865",                                             865,  0 }, 
  { 101, "csibm865",                                        865,  0 }, 
  { 102, "ibm866",                                          866,  0 }, 
  { 102, "cp866",                                           866,  0 }, 
  { 102, "866",                                             866,  0 }, 
  { 102, "csibm866",                                        866,  0 }, 
  { 103, "ibm868",                                            0,  0 }, 
  { 103, "cp868",                                             0,  0 }, 
  { 103, "cp-ar",                                             0,  0 }, 
  { 103, "csibm868",                                          0,  0 }, 
  { 104, "ibm869",                                          869,  0 }, 
  { 104, "cp869",                                           869,  0 }, 
  { 104, "869",                                             869,  0 }, 
  { 104, "cp-gr",                                           869,  0 }, 
  { 104, "csibm869",                                        869,  0 }, 
  { 105, "ibm870",                                          870,  0 }, 
  { 105, "cp870",                                           870,  0 }, 
  { 105, "ebcdic-cp-roece",                                 870,  0 }, 
  { 105, "ebcdic-cp-yu",                                    870,  0 }, 
  { 105, "csibm870",                                        870,  0 }, 
  { 106, "ibm871",                                        20871,  0 }, 
  { 106, "cp871",                                         20871,  0 }, 
  { 106, "ebcdic-cp-is",                                  20871,  0 }, 
  { 106, "csibm871",                                      20871,  0 }, 
  { 106, "x-ebcdic-icelandic",                            20871,  0 }, 
  { 107, "ibm880",                                        20880,  0 }, 
  { 107, "cp880",                                         20880,  0 }, 
  { 107, "ebcdic-cyrillic",                               20880,  0 }, 
  { 107, "csibm880",                                      20880,  0 }, 
  { 107, "x-ebcdic-cyrillicrussian",                      20880,  0 }, 
  { 108, "ibm891",                                            0,  0 }, 
  { 108, "cp891",                                             0,  0 }, 
  { 108, "csibm891",                                          0,  0 }, 
  { 109, "ibm903",                                            0,  0 }, 
  { 109, "cp903",                                             0,  0 }, 
  { 109, "csibm903",                                          0,  0 }, 
  { 110, "ibm904",                                            0,  0 }, 
  { 110, "cp904",                                             0,  0 }, 
  { 110, "904",                                               0,  0 }, 
  { 110, "csibbm904",                                         0,  0 }, 
  { 111, "ibm905",                                        20905,  0 }, 
  { 111, "cp905",                                         20905,  0 }, 
  { 111, "ebcdic-cp-tr",                                  20905,  0 }, 
  { 111, "csibm905",                                      20905,  0 }, 
  { 111, "x-ebcdic-turkish",                              20905,  0 }, 
  { 112, "ibm918",                                            0,  0 }, 
  { 112, "cp918",                                             0,  0 }, 
  { 112, "ebcdic-cp-ar2",                                     0,  0 }, 
  { 112, "csibm918",                                          0,  0 }, 
  { 113, "iso-ir-143",                                        0,  0 }, 
  { 113, "iec_p27-1",                                         0,  0 }, 
  { 113, "csiso143iecp271",                                   0,  0 }, 
  { 114, "iso-ir-49",                                         0,  0 }, 
  { 114, "inis",                                              0,  0 }, 
  { 114, "csiso49inis",                                       0,  0 }, 
  { 115, "iso-ir-50",                                         0,  0 }, 
  { 115, "inis-8",                                            0,  0 }, 
  { 115, "csiso50inis8",                                      0,  0 }, 
  { 116, "iso-ir-51",                                         0,  0 }, 
  { 116, "inis-cyrillic",                                     0,  0 }, 
  { 116, "csiso51iniscyrillic",                               0,  0 }, 
  { 117, "invariant",                                         0,  0 }, 
  { 117, "csinvariant",                                       0,  0 }, 
  { 118, "iso-10646-j-1",                                     0,  0 }, 
  { 119, "iso-10646-ucs-2",                                1200,  0 }, 
  { 119, "csunicode",                                      1200,  0 }, 
  { 119, "unicode",                                        1200,  0 }, 
  { 120, "iso-10646-ucs-4",                                   0,  0 }, 
  { 120, "csucs4",                                            0,  0 }, 
  { 121, "iso-10646-ucs-basic",                               0,  0 }, 
  { 121, "csunicodeascii",                                    0,  0 }, 
  { 122, "iso-10646-unicode-latin1",                          0,  0 }, 
  { 122, "iso-10646",                                         0,  0 }, 
  { 122, "csunicodelatin1",                                   0,  0 }, 
  { 123, "iso-10646-utf-1",                                   0,  0 }, 
  { 123, "csiso10646utf1",                                    0,  0 }, 
  { 124, "iso-2022-cn",                                       0, 1 }, 
  { 125, "iso-2022-cn-ext",                                   0, 1 }, 
  { 126, "iso-2022-jp",                                   50220, 1 }, 
  { 126, "csiso2022jp",                                   50220, 1 }, 
  { 127, "iso-2022-jp-2",                                     0, 1 }, 
  { 127, "csiso2022jp2",                                      0, 1 }, 
  { 128, "iso-2022-kr",                                   50225, 1 }, 
  { 128, "csiso2022kr",                                   50225, 1 }, 
  { 129, "iso-8859-1-windows-3.0-latin-1",                    0,  0 }, 
  { 129, "cswindows30latin1",                                 0,  0 }, 
  { 130, "iso-8859-1-windows-3.1-latin-1",                    0,  0 }, 
  { 130, "cswindows31latin1",                                 0,  0 }, 
  { 131, "iso-8859-10",                                       0,  0 }, 
  { 131, "iso-ir-157",                                        0,  0 }, 
  { 131, "l6",                                                0,  0 }, 
  { 131, "iso_8859-10:1992",                                  0,  0 }, 
  { 131, "csisolatin6",                                       0,  0 }, 
  { 131, "latin6",                                            0,  0 }, 
  { 132, "iso-8859-13",                                   28603,  0 }, 
  { 133, "iso-8859-14",                                       0,  0 }, 
  { 133, "iso-ir-199",                                        0,  0 }, 
  { 133, "iso-celtic",                                        0,  0 }, 
  { 133, "iso_8859-14:1998",                                  0,  0 }, 
  { 133, "iso_8859-14",                                       0,  0 }, 
  { 133, "latin8",                                            0,  0 }, 
  { 133, "l8",                                                0,  0 }, 
  { 134, "iso-8859-15",                                   28605,  0 }, 
  { 134, "iso_8859-15",                                   28605,  0 }, 
  { 134, "latin-9",                                       28605,  0 }, 
  { 134, "l9",                                            28605,  0 }, 
  { 134, "latin9",                                        28605,  0 }, 
  { 135, "iso-8859-16",                                       0,  0 }, 
  { 135, "iso-ir-226",                                        0,  0 }, 
  { 135, "iso_8859-16:2001",                                  0,  0 }, 
  { 135, "iso_8859-16",                                       0,  0 }, 
  { 135, "latin10",                                           0,  0 }, 
  { 135, "l10",                                               0,  0 }, 
  { 136, "iso-8859-2-windows-latin-2",                        0,  0 }, 
  { 136, "cswindows31latin2",                                 0,  0 }, 
  { 137, "iso-8859-9-windows-latin-5",                        0,  0 }, 
  { 137, "cswindows31latin5",                                 0,  0 }, 
  { 138, "iso-ir-90",                                         0,  0 }, 
  { 138, "csiso90",                                           0,  0 }, 
  { 139, "iso-unicode-ibm-1261",                              0,  0 }, 
  { 139, "csunicodeibm1261",                                  0,  0 }, 
  { 140, "iso-unicode-ibm-1264",                              0,  0 }, 
  { 140, "csunicodeibm1264",                                  0,  0 }, 
  { 141, "iso-unicode-ibm-1265",                              0,  0 }, 
  { 141, "csunicodeibm1265",                                  0,  0 }, 
  { 142, "iso-unicode-ibm-1268",                              0,  0 }, 
  { 142, "csunicodeibm1268",                                  0,  0 }, 
  { 143, "iso-unicode-ibm-1276",                              0,  0 }, 
  { 143, "csunicodeibm1276",                                  0,  0 }, 
  { 144, "iso-ir-155",                                        0,  0 }, 
  { 144, "iso_10367-box",                                     0,  0 }, 
  { 144, "csiso10367box",                                     0,  0 }, 
  { 145, "iso-ir-98",                                         0,  0 }, 
  { 145, "iso_2033-1983",                                     0,  0 }, 
  { 145, "e13b",                                              0,  0 }, 
  { 145, "csiso2033",                                         0,  0 }, 
  { 146, "iso-ir-37",                                         0,  0 }, 
  { 146, "iso_5427",                                          0,  0 }, 
  { 146, "csiso5427cyrillic",                                 0,  0 }, 
  { 147, "iso-ir-54",                                         0,  0 }, 
  { 147, "iso_5427:1981",                                     0,  0 }, 
  { 147, "iso5427cyrillic1981",                               0,  0 }, 
  { 148, "iso-ir-55",                                         0,  0 }, 
  { 148, "iso_5428:1980",                                     0,  0 }, 
  { 148, "csiso5428greek",                                    0,  0 }, 
  { 149, "iso_646.basic:1983",                                0,  0 }, 
  { 149, "ref",                                               0,  0 }, 
  { 149, "csiso646basic1983",                                 0,  0 }, 
  { 150, "iso-ir-2",                                      20105,  0 }, 
  { 150, "iso_646.irv:1983",                              20105,  0 }, 
  { 150, "irv",                                           20105,  0 }, 
  { 150, "csiso2intlrefversion",                          20105,  0 }, 
  { 150, "x-ia5",                                         20105,  0 }, 
  { 151, "iso-ir-152",                                        0,  0 }, 
  { 151, "iso_6937-2-25",                                     0,  0 }, 
  { 151, "csiso6937add",                                      0,  0 }, 
  { 152, "iso-ir-142",                                        0,  0 }, 
  { 152, "iso_6937-2-add",                                    0,  0 }, 
  { 152, "csisotextcomm",                                     0,  0 }, 
  { 153, "iso-8859-1",                                    28591,  0 }, 
  { 153, "iso-ir-100",                                    28591,  0 }, 
  { 153, "iso_8859-1:1987",                               28591,  0 }, 
  { 153, "iso_8859-1",                                    28591,  0 }, 
  { 153, "latin1",                                        28591,  0 }, 
  { 153, "l1",                                            28591,  0 }, 
  { 153, "ibm819",                                        28591,  0 }, 
  { 153, "cp819",                                         28591,  0 }, 
  { 153, "csisolatin1",                                   28591,  0 }, 
  { 153, "iso8859-1",                                     28591,  0 }, 
  { 154, "iso-8859-2",                                    28592,  0 }, 
  { 154, "iso-ir-101",                                    28592,  0 }, 
  { 154, "iso_8859-2:1987",                               28592,  0 }, 
  { 154, "iso_8859-2",                                    28592,  0 }, 
  { 154, "latin2",                                        28592,  0 }, 
  { 154, "l2",                                            28592,  0 }, 
  { 154, "csisolatin2",                                   28592,  0 }, 
  { 154, "iso8859-2",                                     28592,  0 }, 
  { 155, "iso-8859-3",                                    28593,  0 }, 
  { 155, "iso-ir-109",                                    28593,  0 }, 
  { 155, "iso_8859-3:1988",                               28593,  0 }, 
  { 155, "iso_8859-3",                                    28593,  0 }, 
  { 155, "latin3",                                        28593,  0 }, 
  { 155, "l3",                                            28593,  0 }, 
  { 155, "csisolatin3",                                   28593,  0 }, 
  { 156, "iso-8859-4",                                    28594,  0 }, 
  { 156, "iso-ir-110",                                    28594,  0 }, 
  { 156, "iso_8859-4:1988",                               28594,  0 }, 
  { 156, "iso_8859-4",                                    28594,  0 }, 
  { 156, "latin4",                                        28594,  0 }, 
  { 156, "l4",                                            28594,  0 }, 
  { 156, "csisolatin4",                                   28594,  0 }, 
  { 157, "iso-8859-5",                                    28595,  0 }, 
  { 157, "iso-ir-144",                                    28595,  0 }, 
  { 157, "iso_8859-5:1988",                               28595,  0 }, 
  { 157, "iso_8859-5",                                    28595,  0 }, 
  { 157, "cyrillic",                                      28595,  0 }, 
  { 157, "csisolatincyrillic",                            28595,  0 }, 
  { 158, "iso-8859-6-e",                                      0,  0 }, 
  { 158, "iso_8859-6-e",                                      0,  0 }, 
  { 158, "csiso88596e",                                       0,  0 }, 
  { 159, "iso-8859-6-i",                                      0,  0 }, 
  { 159, "iso_8859-6-i",                                      0,  0 }, 
  { 159, "csiso88596i",                                       0,  0 }, 
  { 160, "iso-8859-6",                                    28596,  0 }, 
  { 160, "iso-ir-127",                                    28596,  0 }, 
  { 160, "iso_8859-6:1987",                               28596,  0 }, 
  { 160, "iso_8859-6",                                    28596,  0 }, 
  { 160, "ecma-114",                                      28596,  0 }, 
  { 160, "asmo-708",                                      28596,  0 }, 
  { 160, "arabic",                                        28596,  0 }, 
  { 160, "csisolatinarabic",                              28596,  0 }, 
  { 161, "iso-8859-7",                                    28597,  0 }, 
  { 161, "iso-ir-126",                                    28597,  0 }, 
  { 161, "iso_8859-7:1987",                               28597,  0 }, 
  { 161, "iso_8859-7",                                    28597,  0 }, 
  { 161, "elot_928",                                      28597,  0 }, 
  { 161, "ecma-118",                                      28597,  0 }, 
  { 161, "greek",                                         28597,  0 }, 
  { 161, "greek8",                                        28597,  0 }, 
  { 161, "csisolatingreek",                               28597,  0 }, 
  { 162, "iso-8859-8-e",                                      0,  0 }, 
  { 162, "iso_8859-8-e",                                      0,  0 }, 
  { 162, "csiso88598e",                                       0,  0 }, 
  { 163, "iso-8859-8-i",                                  38598,  0 }, 
  { 163, "iso_8859-8-i",                                  38598,  0 }, 
  { 163, "csiso88598i",                                   38598,  0 }, 
  { 164, "iso-8859-8",                                    28598,  0 }, 
  { 164, "iso-ir-138",                                    28598,  0 }, 
  { 164, "iso_8859-8:1988",                               28598,  0 }, 
  { 164, "iso_8859-8",                                    28598,  0 }, 
  { 164, "hebrew",                                        28598,  0 }, 
  { 164, "csisolatinhebrew",                              28598,  0 }, 
  { 164, "logical",                                       28598,  0 }, 
  { 164, "visual",                                        28598,  0 }, 
  { 165, "iso-8859-9",                                    28599,  0 }, 
  { 165, "iso-ir-148",                                    28599,  0 }, 
  { 165, "iso_8859-9:1989",                               28599,  0 }, 
  { 165, "iso_8859-9",                                    28599,  0 }, 
  { 165, "latin5",                                        28599,  0 }, 
  { 165, "l5",                                            28599,  0 }, 
  { 165, "csisolatin5",                                   28599,  0 }, 
  { 166, "iso-ir-154",                                        0,  0 }, 
  { 166, "iso_8859-supp",                                     0,  0 }, 
  { 166, "latin1-2-5",                                        0,  0 }, 
  { 166, "csiso8859supp",                                     0,  0 }, 
  { 167, "iso-ir-15",                                         0,  0 }, 
  { 167, "it",                                                0,  0 }, 
  { 167, "iso646-it",                                         0,  0 }, 
  { 167, "csiso15italian",                                    0,  0 }, 
  { 168, "iso-ir-13",                                         0,  0 }, 
  { 168, "jis_c6220-1969-jp",                                 0,  0 }, 
  { 168, "jis_c6220-1969",                                    0,  0 }, 
  { 168, "katakana",                                          0,  0 }, 
  { 168, "x0201-7",                                           0,  0 }, 
  { 168, "csiso13jisc6220jp",                                 0,  0 }, 
  { 169, "iso-ir-14",                                         0,  0 }, 
  { 169, "jis_c6220-1969-ro",                                 0,  0 }, 
  { 169, "jp",                                                0,  0 }, 
  { 169, "iso646-jp",                                         0,  0 }, 
  { 169, "csiso14jisc6220ro",                                 0,  0 }, 
  { 170, "iso-ir-42",                                         0,  0 }, 
  { 170, "jis_c6226-1978",                                    0,  0 }, 
  { 170, "csiso42jisc62261978",                               0,  0 }, 
  { 171, "iso-ir-87",                                         0,  0 }, 
  { 171, "jis_c6226-1983",                                    0,  0 }, 
  { 171, "x0208",                                             0,  0 }, 
  { 171, "jis_x0208-1983",                                    0,  0 }, 
  { 171, "csiso87jisx0208",                                   0,  0 }, 
  { 172, "iso-ir-91",                                         0,  0 }, 
  { 172, "jis_c6229-1984-a",                                  0,  0 }, 
  { 172, "jp-ocr-a",                                          0,  0 }, 
  { 172, "csiso91jisc62291984a",                              0,  0 }, 
  { 173, "iso-ir-92",                                         0,  0 }, 
  { 173, "jis_c6229-1984-b",                                  0,  0 }, 
  { 173, "iso646-jp-ocr-b",                                   0,  0 }, 
  { 173, "jp-ocr-b",                                          0,  0 }, 
  { 173, "csiso92jisc62991984b",                              0,  0 }, 
  { 174, "iso-ir-93",                                         0,  0 }, 
  { 174, "jis_c6229-1984-b-add",                              0,  0 }, 
  { 174, "jp-ocr-b-add",                                      0,  0 }, 
  { 174, "csiso93jis62291984badd",                            0,  0 }, 
  { 175, "iso-ir-94",                                         0,  0 }, 
  { 175, "jis_c6229-1984-hand",                               0,  0 }, 
  { 175, "jp-ocr-hand",                                       0,  0 }, 
  { 175, "csiso94jis62291984hand",                            0,  0 }, 
  { 176, "iso-ir-95",                                         0,  0 }, 
  { 176, "jis_c6229-1984-hand-add",                           0,  0 }, 
  { 176, "jp-ocr-hand-add",                                   0,  0 }, 
  { 176, "csiso95jis62291984handadd",                         0,  0 }, 
  { 177, "iso-ir-96",                                         0,  0 }, 
  { 177, "jis_c6229-1984-kana",                               0,  0 }, 
  { 177, "csiso96jisc62291984kana",                           0,  0 }, 
  { 178, "jis_encoding",                                      0,  0 }, 
  { 178, "csjisencoding",                                     0,  0 }, 
  { 179, "jis_x0201",                                         0,  0 }, 
  { 179, "x0201",                                             0,  0 }, 
  { 179, "cshalfwidthkatakana",                               0,  0 }, 
  { 180, "iso-ir-159",                                        0,  0 }, 
  { 180, "jis_x0212-1990",                                    0,  0 }, 
  { 180, "x0212",                                             0,  0 }, 
  { 180, "csiso159jisx02121990",                              0,  0 }, 
  { 181, "iso-ir-141",                                        0,  0 }, 
  { 181, "jus_i.b1.002",                                      0,  0 }, 
  { 181, "iso646-yu",                                         0,  0 }, 
  { 181, "js",                                                0,  0 }, 
  { 181, "yu",                                                0,  0 }, 
  { 181, "csiso141jusib1002",                                 0,  0 }, 
  { 182, "iso-ir-147",                                        0,  0 }, 
  { 182, "jus_i.b1.003-mac",                                  0,  0 }, 
  { 182, "macedonian",                                        0,  0 }, 
  { 182, "csiso147macedonian",                                0,  0 }, 
  { 183, "iso-ir-146",                                        0,  0 }, 
  { 183, "jus_i.b1.003-serb",                                 0,  0 }, 
  { 183, "serbian",                                           0,  0 }, 
  { 183, "csiso146serbian",                                   0,  0 }, 
  { 184, "koi8-r",                                        20866,  0 }, 
  { 184, "cskoi8r",                                       20866,  0 }, 
  { 184, "koi8",                                          20866,  0 }, 
  { 184, "koi",                                           20866,  0 }, 
  { 184, "koi8r",                                         20866,  0 }, 
  { 185, "koi8-u",                                        21866,  0 }, 
  { 185, "koi8-ru",                                       21866,  0 }, 
  { 186, "iso-ir-149",                                      949,  0 }, 
  { 186, "ks_c_5601-1987",                                  949,  0 }, 
  { 186, "ks_c_5601-1989",                                  949,  0 }, 
  { 186, "ksc_5601",                                        949,  0 }, 
  { 186, "korean",                                          949,  0 }, 
  { 186, "csksc56011987",                                   949,  0 }, 
  { 186, "ks_c_5601_1987",                                  949,  0 }, 
  { 186, "ksc5601",                                         949,  0 }, 
  { 186, "ks_c_5601",                                       949,  0 }, 
  { 187, "ksc5636",                                           0,  0 }, 
  { 187, "iso646-kr",                                         0,  0 }, 
  { 187, "csksc5636",                                         0,  0 }, 
  { 188, "iso-ir-19",                                         0,  0 }, 
  { 188, "latin-greek",                                       0,  0 }, 
  { 188, "csiso19latingreek",                                 0,  0 }, 
  { 189, "iso-ir-27",                                         0,  0 }, 
  { 189, "latin-greek-1",                                     0,  0 }, 
  { 189, "csiso27latingreek1",                                0,  0 }, 
  { 190, "iso-ir-158",                                        0,  0 }, 
  { 190, "latin-lap",                                         0,  0 }, 
  { 190, "lap",                                               0,  0 }, 
  { 190, "csiso158lap",                                       0,  0 }, 
  { 191, "macintosh",                                     10000,  0 }, 
  { 191, "mac",                                           10000,  0 }, 
  { 191, "csmacintosh",                                   10000,  0 }, 
  { 192, "microsoft-publishing",                              0,  0 }, 
  { 192, "csmicrosoftpublishing",                             0,  0 }, 
  { 193, "mnem",                                              0,  0 }, 
  { 193, "csmnem",                                            0,  0 }, 
  { 194, "mnemonic",                                          0,  0 }, 
  { 194, "csmnemonic",                                        0,  0 }, 
  { 195, "iso-ir-86",                                         0,  0 }, 
  { 195, "msz_7795.3",                                        0,  0 }, 
  { 195, "iso646-hu",                                         0,  0 }, 
  { 195, "hu",                                                0,  0 }, 
  { 195, "csiso86hungarian",                                  0,  0 }, 
  { 196, "iso-ir-9-1",                                        0,  0 }, 
  { 196, "nats-dano",                                         0,  0 }, 
  { 196, "csnatsdano",                                        0,  0 }, 
  { 197, "iso-ir-9-2",                                        0,  0 }, 
  { 197, "nats-dano-add",                                     0,  0 }, 
  { 197, "csnatsdanoadd",                                     0,  0 }, 
  { 198, "iso-ir-8-1",                                        0,  0 }, 
  { 198, "nats-sefi",                                         0,  0 }, 
  { 198, "csnatssefi",                                        0,  0 }, 
  { 199, "iso-ir-8-2",                                        0,  0 }, 
  { 199, "nats-sefi-add",                                     0,  0 }, 
  { 199, "csnatssefiadd",                                     0,  0 }, 
  { 200, "iso-ir-151",                                        0,  0 }, 
  { 200, "nc_nc00-10:81",                                     0,  0 }, 
  { 200, "cuba",                                              0,  0 }, 
  { 200, "iso646-cu",                                         0,  0 }, 
  { 200, "csiso151cuba",                                      0,  0 }, 
  { 201, "iso-ir-69",                                         0,  0 }, 
  { 201, "nf_z_62-010",                                       0,  0 }, 
  { 201, "iso646-fr",                                         0,  0 }, 
  { 201, "fr",                                                0,  0 }, 
  { 201, "csiso69french",                                     0,  0 }, 
  { 202, "iso-ir-25",                                         0,  0 }, 
  { 202, "nf_z_62-010_(1973)",                                0,  0 }, 
  { 202, "iso646-fr1",                                        0,  0 }, 
  { 202, "csiso25french",                                     0,  0 }, 
  { 203, "iso-ir-60",                                     20108,  0 }, 
  { 203, "ns_4551-1",                                     20108,  0 }, 
  { 203, "iso646-0",                                     20108,  0 }, 
  { 203, "0",                                            20108,  0 }, 
  { 203, "csiso60danishnorwegian",                        20108,  0 }, 
  { 203, "csiso60norwegian1",                             20108,  0 }, 
  { 203, "x-ia5-norwegian",                               20108,  0 }, 
  { 204, "iso-ir-61",                                         0,  0 }, 
  { 204, "ns_4551-2",                                         0,  0 }, 
  { 204, "iso646-no2",                                        0,  0 }, 
  { 204, "no2",                                               0,  0 }, 
  { 204, "csiso61norwegian2",                                 0,  0 }, 
  { 205, "pc8-danish-norwegian",                              0,  0 }, 
  { 205, "cspc8danishnorwegian",                              0,  0 }, 
  { 206, "pc8-turkish",                                       0,  0 }, 
  { 206, "cspc8turkish",                                      0,  0 }, 
  { 207, "iso-ir-16",                                         0,  0 }, 
  { 207, "pt",                                                0,  0 }, 
  { 207, "iso646-pt",                                         0,  0 }, 
  { 207, "csiso16portuguese",                                 0,  0 }, 
  { 208, "iso-ir-84",                                         0,  0 }, 
  { 208, "pt2",                                               0,  0 }, 
  { 208, "iso646-pt2",                                        0,  0 }, 
  { 208, "csiso84portuguese2",                                0,  0 }, 
  { 209, "ptcp154",                                           0,  0 }, 
  { 209, "csptcp154",                                         0,  0 }, 
  { 209, "pt154",                                             0,  0 }, 
  { 209, "cp154",                                             0,  0 }, 
  { 209, "cyrillic-asian",                                    0,  0 }, 
  { 210, "scsu",                                              0,  0 }, 
  { 211, "iso-ir-10",                                     20107,  0 }, 
  { 211, "sen_850200_b",                                  20107,  0 }, 
  { 211, "fi",                                            20107,  0 }, 
  { 211, "iso646-fi",                                     20107,  0 }, 
  { 211, "iso646-se",                                     20107,  0 }, 
  { 211, "se",                                            20107,  0 }, 
  { 211, "csiso10swedish",                                20107,  0 }, 
  { 211, "x-ia5-swedish",                                 20107,  0 }, 
  { 212, "iso-ir-11",                                         0,  0 }, 
  { 212, "sen_850200_c",                                      0,  0 }, 
  { 212, "iso646-se2",                                        0,  0 }, 
  { 212, "se2",                                               0,  0 }, 
  { 212, "csiso11swedishfornames",                            0,  0 }, 
  { 213, "shift_jis",                                       932,  0 }, 
  { 213, "ms_kanji",                                        932,  0 }, 
  { 213, "csshiftjis",                                      932,  0 }, 
  { 213, "shift-jis",                                       932,  0 }, 
  { 213, "x-ms-cp932",                                      932,  0 }, 
  { 213, "x-sjis",                                          932,  0 }, 
  { 214, "iso-ir-128",                                        0,  0 }, 
  { 214, "t.101-g2",                                          0,  0 }, 
  { 214, "csiso128t101g2",                                    0,  0 }, 
  { 215, "iso-ir-102",                                        0,  0 }, 
  { 215, "t.61-7bit",                                         0,  0 }, 
  { 215, "csiso102t617bit",                                   0,  0 }, 
  { 216, "iso-ir-103",                                        0,  0 }, 
  { 216, "t.61-8bit",                                         0,  0 }, 
  { 216, "t.61",                                              0,  0 }, 
  { 216, "csiso103t618bit",                                   0,  0 }, 
  { 217, "tis-620",                                         874,  0 }, 
  { 217, "windows-874",                                     874,  0 }, 
  { 217, "iso-8859-11",                                     874,  0 }, 
  { 217, "dos-874",                                         874,  0 }, 
  { 218, "unicode-1-1",                                       0,  0 }, 
  { 218, "csunicode11",                                       0,  0 }, 
  { 219, "unicode-1-1-utf-7",                             65000, 1 }, 
  { 219, "csunicode11utf7",                               65000, 1 }, 
  { 219, "x-unicode-2-0-utf-7",                           65000, 1 }, 
  { 220, "unknown-8bit",                                      0,  0 }, 
  { 220, "csunknown8bit",                                     0,  0 }, 
  { 221, "us-dk",                                             0,  0 }, 
  { 221, "csusdk",                                            0,  0 }, 
  { 222, "utf-16",                                         1200,  0 }, 
  { 222, "unicode",                                        1200,  0 }, 
  { 223, "utf-16be",                                       1201,  0 }, 
  { 223, "unicodefffe",                                    1201,  0 }, 
  { 224, "utf-16le",                                       1200,  0 }, 
  { 224, "unicode",                                        1200,  0 }, 
  { 225, "utf-32",                                            0,  0 }, 
  { 226, "utf-32be",                                          0,  0 }, 
  { 227, "utf-32le",                                          0,  0 }, 
  { 228, "utf-7",                                         65000, 1 }, 
  { 228, "x-unicode-2-0-utf-7",                           65000, 1 }, 
  { 229, "utf-8",                                         65001,  0 }, 
  { 229, "unicode-2-0-utf-8",                             65001,  0 }, 
  { 229, "unicode-1-1-utf-8",                             65001,  0 }, 
  { 229, "x-unicode-2-0-utf-8",                           65001,  0 }, 
  { 230, "ventura-international",                             0,  0 }, 
  { 230, "csventurainternational",                            0,  0 }, 
  { 231, "ventura-math",                                      0,  0 }, 
  { 231, "csventuramath",                                     0,  0 }, 
  { 232, "ventura-us",                                        0,  0 }, 
  { 232, "csventuraus",                                       0,  0 }, 
  { 233, "iso-ir-70",                                         0,  0 }, 
  { 233, "videotex-suppl",                                    0,  0 }, 
  { 233, "csiso70videotexsupp1",                              0,  0 }, 
  { 234, "viqr",                                              0,  0 }, 
  { 234, "csviqr",                                            0,  0 }, 
  { 235, "viscii",                                            0,  0 }, 
  { 235, "csviscii",                                          0,  0 }, 
  { 236, "windows-1250",                                   1250,  0 }, 
  { 236, "x-cp1250",                                       1250,  0 }, 
  { 237, "windows-1251",                                   1251,  0 }, 
  { 237, "x-cp1251",                                       1251,  0 }, 
  { 238, "windows-1252",                                   1252,  0 }, 
  { 238, "x-ansi",                                         1252,  0 }, 
  { 239, "windows-1253",                                   1253,  0 }, 
  { 240, "windows-1254",                                   1254,  0 }, 
  { 241, "windows-1255",                                   1255,  0 }, 
  { 242, "windows-1256",                                   1256,  0 }, 
  { 242, "cp1256",                                         1256,  0 }, 
  { 243, "windows-1257",                                   1257,  0 }, 
  { 244, "windows-1258",                                   1258,  0 }, 
  { 245, "windows-31j",                                     932,  0 }, 
  { 245, "cswindows31j",                                    932,  0 }, 
  { 245, "shift-jis",                                       932,  0 }, 
  { 245, "x-ms-cp932",                                      932,  0 }, 
  { 245, "x-sjis",                                          932,  0 }, 
  { 246, "dos-720",                                         720,  0 }, 
  { 247, "euc-cn",                                        51936,  0 }, 
  { 248, "ibm737",                                          737,  0 }, 
  { 249, "johab",                                          1361,  0 }, 
  { 250, "x-chinese-cns",                                 20000,  0 }, 
  { 251, "x-chinese-eten",                                20002,  0 }, 
  { 252, "x-ebcdic-cyrillicserbianbulgarian",             21025,  0 }, 
  { 253, "x-ebcdic-greekmodern",                            875,  0 }, 
  { 254, "x-ebcdic-japaneseandjapaneselatin",             50939,  0 }, 
  { 255, "x-ebcdic-japaneseandkana",                      50930,  0 }, 
  { 256, "x-ebcdic-japaneseanduscanada",                  50931,  0 }, 
  { 257, "x-ebcdic-koreanandkoreanextended",              50933,  0 }, 
  { 258, "x-ebcdic-koreanextended",                       20833,  0 }, 
  { 259, "x-ebcdic-simplifiedchinese",                    50935,  0 }, 
  { 260, "x-ebcdic-traditionalchinese",                   50937,  0 }, 
  { 261, "x-euc-cn",                                      51936,  0 }, 
  { 262, "x-europa",                                      29001,  0 }, 
  { 263, "x-iscii-as",                                    57006,  0 }, 
  { 264, "x-iscii-be",                                    57003,  0 }, 
  { 265, "x-iscii-de",                                    57002,  0 }, 
  { 266, "x-iscii-gu",                                    57010,  0 }, 
  { 267, "x-iscii-ka",                                    57008,  0 }, 
  { 268, "x-iscii-ma",                                    57009,  0 }, 
  { 269, "x-iscii-or",                                    57007,  0 }, 
  { 270, "x-iscii-pa",                                    57011,  0 }, 
  { 271, "x-iscii-ta",                                    57004,  0 }, 
  { 272, "x-iscii-te",                                    57005,  0 }, 
  { 273, "x-mac-arabic",                                  10004,  0 }, 
  { 274, "x-mac-ce",                                      10029,  0 }, 
  { 275, "x-mac-chinesesimp",                             10008,  0 }, 
  { 276, "x-mac-chinesetrad",                             10002,  0 }, 
  { 277, "x-mac-cyrillic",                                10007,  0 }, 
  { 278, "x-mac-greek",                                   10006,  0 }, 
  { 279, "x-mac-hebrew",                                  10005,  0 }, 
  { 280, "x-mac-icelandic",                               10079,  0 }, 
  { 281, "x-mac-japanese",                                10001,  0 }, 
  { 282, "x-mac-korean",                                  10003,  0 }, 
  { 283, "x-mac-turkish",                                 10081,  0 }, 

  
  {   0, NULL,                                                0,  0 }
};

vmsCharsets::vmsCharsets()
{

}

vmsCharsets::~vmsCharsets()
{

}

UINT vmsCharsets::GetCpIdFromName(LPCSTR pszName)
{
	for (int i = 0; charsetInfo [i].id; i++)
	{
		if (stricmp (pszName, charsetInfo [i].charset) == 0)
			return charsetInfo [i].codepage;
	}

	return 0;
}

void vmsCharsets::DecodeString(LPCSTR pszString, UINT nCodePage, wstring &wstrResult)
{
	int n = MultiByteToWideChar (nCodePage, 0, pszString, -1, NULL, 0);
	assert (n != 0);
	LPWSTR pwsz = new WCHAR [n+1];
	MultiByteToWideChar (nCodePage, 0, pszString, -1, pwsz, n);
	wstrResult = pwsz;
	delete [] pwsz;
}
