/*
  Free Download Manager Copyright (c) 2003-2011 FreeDownloadManager.ORG
*/



#ifndef AVUTIL_PIXFMT_H
#define AVUTIL_PIXFMT_H



#include "libavutil/avconfig.h"


enum PixelFormat {
    PIX_FMT_NONE= -1,
    PIX_FMT_YUV420P,   
    PIX_FMT_YUYV422,   
    PIX_FMT_RGB24,     
    PIX_FMT_BGR24,     
    PIX_FMT_YUV422P,   
    PIX_FMT_YUV444P,   
    PIX_FMT_YUV410P,   
    PIX_FMT_YUV411P,   
    PIX_FMT_GRAY8,     
    PIX_FMT_MONOWHITE, 
    PIX_FMT_MONOBLACK, 
    PIX_FMT_PAL8,      
    PIX_FMT_YUVJ420P,  
    PIX_FMT_YUVJ422P,  
    PIX_FMT_YUVJ444P,  
    PIX_FMT_XVMC_MPEG2_MC,
    PIX_FMT_XVMC_MPEG2_IDCT,
    PIX_FMT_UYVY422,   
    PIX_FMT_UYYVYY411, 
    PIX_FMT_BGR8,      
    PIX_FMT_BGR4,      
    PIX_FMT_BGR4_BYTE, 
    PIX_FMT_RGB8,      
    PIX_FMT_RGB4,      
    PIX_FMT_RGB4_BYTE, 
    PIX_FMT_NV12,      
    PIX_FMT_NV21,      

    PIX_FMT_ARGB,      
    PIX_FMT_RGBA,      
    PIX_FMT_ABGR,      
    PIX_FMT_BGRA,      

    PIX_FMT_GRAY16BE,  
    PIX_FMT_GRAY16LE,  
    PIX_FMT_YUV440P,   
    PIX_FMT_YUVJ440P,  
    PIX_FMT_YUVA420P,  
    PIX_FMT_VDPAU_H264,
    PIX_FMT_VDPAU_MPEG1,
    PIX_FMT_VDPAU_MPEG2,
    PIX_FMT_VDPAU_WMV3,
    PIX_FMT_VDPAU_VC1, 
    PIX_FMT_RGB48BE,   
    PIX_FMT_RGB48LE,   

    PIX_FMT_RGB565BE,  
    PIX_FMT_RGB565LE,  
    PIX_FMT_RGB555BE,  
    PIX_FMT_RGB555LE,  

    PIX_FMT_BGR565BE,  
    PIX_FMT_BGR565LE,  
    PIX_FMT_BGR555BE,  
    PIX_FMT_BGR555LE,  

    PIX_FMT_VAAPI_MOCO, 
    PIX_FMT_VAAPI_IDCT, 
    PIX_FMT_VAAPI_VLD,  

    PIX_FMT_YUV420P16LE,  
    PIX_FMT_YUV420P16BE,  
    PIX_FMT_YUV422P16LE,  
    PIX_FMT_YUV422P16BE,  
    PIX_FMT_YUV444P16LE,  
    PIX_FMT_YUV444P16BE,  
    PIX_FMT_VDPAU_MPEG4,  
    PIX_FMT_DXVA2_VLD,    

    PIX_FMT_RGB444BE,  
    PIX_FMT_RGB444LE,  
    PIX_FMT_BGR444BE,  
    PIX_FMT_BGR444LE,  
    PIX_FMT_Y400A,     
    PIX_FMT_NB,        
};

#if AV_HAVE_BIGENDIAN
#   define PIX_FMT_NE(be, le) PIX_FMT_##be
#else
#   define PIX_FMT_NE(be, le) PIX_FMT_##le
#endif

#define PIX_FMT_RGB32   PIX_FMT_NE(ARGB, BGRA)
#define PIX_FMT_RGB32_1 PIX_FMT_NE(RGBA, ABGR)
#define PIX_FMT_BGR32   PIX_FMT_NE(ABGR, RGBA)
#define PIX_FMT_BGR32_1 PIX_FMT_NE(BGRA, ARGB)

#define PIX_FMT_GRAY16 PIX_FMT_NE(GRAY16BE, GRAY16LE)
#define PIX_FMT_RGB48  PIX_FMT_NE(RGB48BE,  RGB48LE)
#define PIX_FMT_RGB565 PIX_FMT_NE(RGB565BE, RGB565LE)
#define PIX_FMT_RGB555 PIX_FMT_NE(RGB555BE, RGB555LE)
#define PIX_FMT_RGB444 PIX_FMT_NE(RGB444BE, RGB444LE)
#define PIX_FMT_BGR565 PIX_FMT_NE(BGR565BE, BGR565LE)
#define PIX_FMT_BGR555 PIX_FMT_NE(BGR555BE, BGR555LE)
#define PIX_FMT_BGR444 PIX_FMT_NE(BGR444BE, BGR444LE)

#define PIX_FMT_YUV420P16 PIX_FMT_NE(YUV420P16BE, YUV420P16LE)
#define PIX_FMT_YUV422P16 PIX_FMT_NE(YUV422P16BE, YUV422P16LE)
#define PIX_FMT_YUV444P16 PIX_FMT_NE(YUV444P16BE, YUV444P16LE)

#endif 
